#!/usr/bin/perl -w
#
# 2004.02.01 08:07:00
# Jason Dixon

use strict;
use HTML::Template;
use CGI;
use DBI;

##############################################
# Configuration Section
##############################################
my $db_file = "/var/db/pflog.db";
##############################################


my $dbh = DBI->connect("DBI:SQLite:dbname=$db_file", "", "") || die $DBI::errstr;
my $cgi = CGI->new;
my $select_query = "select * from logs where date like ? order by ";

if ($cgi->param('sort')) {
	SWITCH: {
		if ($cgi->param('sort') eq 'rule') { $select_query .= "rulenum"; last SWITCH; }
		if ($cgi->param('sort') eq 'proto') { $select_query .= "proto"; last SWITCH; }
		if ($cgi->param('sort') eq 'action') { $select_query .= "action"; last SWITCH; }
		if ($cgi->param('sort') eq 'intf') { $select_query .= "interface"; last SWITCH; }
		if ($cgi->param('sort') eq 'src') { $select_query .= "src_host"; last SWITCH; }
		if ($cgi->param('sort') eq 'dst') { $select_query .= "dst_host"; last SWITCH; }
		if ($cgi->param('sort') eq 'svc') { $select_query .= "dst_port"; last SWITCH; }
		$select_query .= "date";
	}
} else {
	$select_query .= "date";
}

$select_query .= " desc" if ($cgi->param('d') eq 'desc');

my $sth = $dbh->prepare($select_query);
my $time = localtime;
my ($date, $day, $date_def);

# From navigation form
if ($cgi->param('month')) {
	if ($cgi->param('day') =~ /^\d$/) {
		$day = '0' . $cgi->param('day');
	} else {
		$day = $cgi->param('day');
	}
	$date = $cgi->param('month') . ' ' . $day;
# From column links
} elsif ($cgi->param('date')) {
	$date = $cgi->param('date');
# Everywhere else
} else {
	if ([split(/ /,localtime)]->[2] =~ /^\d$/) {
		$day = '0' . [split(/ /,localtime)]->[2];
	} else {
		$day = [split(/ /,localtime)]->[2];
	}
	$date = [split(/ /,localtime)]->[1] . ' ' . $day;
	undef $date_def;
}

my $date_param = '&date=' . $date;
$date =~ s/(^.*$)/\%$1\%/;
$sth->execute($date);
my @log_loop;

while (my $result = $sth->fetchrow_hashref) {
	unless ($result->{'src_host'} eq 'encrypted') {
		$result->{'src_host'} = "<a href=\"http://www.dnsstuff.com/tools/ptr.ch?ip=$result->{'src_host'}\" target=\"new\">$result->{'src_host'}</a>";
	}
	if ($result->{'dst_port'} =~ /^\d+$/) {
		$result->{'dst_port'} = "<a href=\"http://isc.incidents.org/port_details.html?port=$result->{'dst_port'}\" target=\"new\">$result->{'dst_port'}</a>";
	}
	push(@log_loop, $result);
}

my $template = HTML::Template->new(filename => '../templates/output.tmpl', die_on_bad_params => 0);
$template->param(time => $time, date => $date_param, data => \@log_loop);
$template->param(opts => '&d=desc') unless ($cgi->param('d') eq 'desc');
print "Content-Type: text/html\n\n", $template->output;

